function CGame(oData) {

    var _oInterface;
    var _oHelpPanel;
    var _iCurrWaveIndex;
    var _iScore;
    var _iZombie;
    var _iCurrState; //WAITING, IN-GAME, RELOADING
    var _aWaveTargets;
    var _aZombiesInGame;
    var _iWaveTimer;
    var _bOccurrencesSet;
    var _iSpawnTimer;
    var _iZombieOnScreen;
    var _aZombiePool;
    var _aZombieToRemove;
    var _aZombiesOccurrences;
    var _bSpawnTimer;
    var _bAnimEnded;
    var _bPause = false;
    var _iZombieCount;
    var _oContainer;
    var _oAllZombieContainer;
    var _oBgContainer;
    var _oFade;
    var _aBgpng;
    var _bAnimTick;
    var _oPlayer;
    var _iFrame;
    var _bWaveStarted;
    var _bWaveSpawnComplete;
    var _bNormalAnim;
    var _oEndPanel;
    var _bCanShoot;
    var _aZombieOnStage; //Bidimensional Array: 1st Index sets the wave, 2nd Index sets the occurrences of each wave
    this._init = function ()
    {
        s_oGame = this;
        PLAYER_HEALTH = oData.iPlayerHealth;
        ZOMBIE_HEALTHS = oData.aZombieHealth;
        SPAWN_INTERVAL = oData.iSpawnInterval;
        WAITING_TIME = oData.iWaveInterval;
        WAVE_TARGET = oData.aAmountZombiesOnStage;
        MAX_ZOMBIE_ON_SCREEN = oData.iZombieOnScreen;
        
        _bCanShoot = true;
        _oFade = new createjs.Shape();
        _oFade.graphics.beginFill("#000").drawRect(0 , 10, CANVAS_WIDTH + 20, CANVAS_HEIGHT +20);
        _bWaveStarted = false;
        _oFade.alpha = 0.01;
        _bAnimTick = true;
        setVolume("soundtrack", SOUNDTRACK_VOLUME_IN_GAME );
        playSound("zombie_crowd", 1,true);
        
        playSound("dog_horde", 1,true);

        _oContainer = new createjs.Container();
        s_oStage.addChild(_oContainer);
        _bWaveSpawnComplete = false;
        _oContainer.x = -20;
        _oContainer.y = -20;
        _aBgpng = [];
        _oBgContainer = new createjs.Container();
        for (var i = 0; i < 57; i++){
            _aBgpng[i] = createBitmap(s_oSpriteLibrary.getSprite("bg"+i));
            _aBgpng[i].visible=false;
            _oBgContainer.addChild(_aBgpng[i]);
        }
        _iZombieOnScreen = 0;
        _iFrame = 0;
        _oAllZombieContainer = new createjs.Container();
        _oContainer.addChild(_oFade);
        _oContainer.addChild(_oBgContainer);
        _oContainer.addChild(_oAllZombieContainer);
        _oBgContainer.on("mousedown", this.Shoot);
        _iCurrWaveIndex = 0;
        _iZombieCount = 0;
        _iWaveTimer = 0;
        _iSpawnTimer = 0;
        _aZombiesOccurrences = [];
        _aZombieOnStage = [];			//Bidimensional Array, 1st index rapresent the wave, 2nd index rapresent the occurrences
        _bAnimEnded = true;
        _bNormalAnim = true;
        _aZombieOnStage = oData.aZombieOnStage;



        _aZombiePool = [];          //Zombie Available
        _aZombiesInGame = [];       //Zombie which update is in progress
        _aZombieToRemove = [];      //Zombie who need to be removed


        for (var i = 0; i < WAVE_TARGET[WAVE_TARGET.length -1]; i++)
        {
            _aZombiePool.push(new CZombie(0, -1000, -1000, _oAllZombieContainer));
        }
        _aWaveTargets = WAVE_TARGET;
        _iScore = 0;
        _iZombie = 0;
        _iCurrState = 0;
        _bOccurrencesSet = false;
        _bSpawnTimer = false;
        _oPlayer = new CPlayer();
        _oInterface = new CInterface();
        _oHelpPanel = new CHelpPanel();
        _oEndPanel = new  CEndPanel(_iScore);
       
        
        if (getItem(FIRST_TIME_ITEM_NAME) !== false)
        {
            saveItem(FIRST_TIME_ITEM_NAME, true);
            _oHelpPanel.show();
        }
        if (!s_bMobile)
        {
            
          document.onkeydown = function(event) {
                if (event.keyCode === 82)
                {
                    
                    _oInterface.ammoReload();
                }
                event.preventDefault();
                return false;
		};
        }
        
        $(s_oMain).trigger("start_level", 1);
    };


    this.unload = function () {
       
           _oInterface.unload();
           _oHelpPanel.unload();
        s_oStage.removeAllChildren();
document.onkeydown = null;

        s_oGame = null;
    };
    
    this.showHelp = function ()
    {
        _oHelpPanel.show();
    };
    
    this.toggleShoot = function (bool)
    {
      _bCanShoot = bool;
    };
    
    this.togglePause = function () 
    {
       _oPlayer.setVisible (_bPause); 
      _bPause = !_bPause;  
    };
    
    this.onExit = function ()
    {
        setVolume("soundtrack", 1);
        stopSound("dog_horde");
       stopSound("zombie_crowd");
        _oContainer.x = -20;
        _oContainer.y = -20;
        createjs.Tween.removeAllTweens();
        s_oGame.unload();
        s_oMain.gotoMenu();

        $(s_oMain).trigger("end_session");
        $(s_oMain).trigger("show_interlevel_ad");
    };

    this.restart = function ()
    {   $(s_oMain).trigger("restart_level", 1);
        this.unload();
        this._init();
    };

    this.setOccurrences = function () {
        var iWave = _iCurrWaveIndex;
        if (iWave > _aZombieOnStage.length)
        {
            iWave = _aZombieOnStage.length - 1;
        }
        _aZombiesOccurrences = [];
        for(var j = 0; j < _aZombieOnStage[iWave].length; j++)
        {
            for (var i = 0; i < _aZombieOnStage[iWave][j]; i++)
            {
                _aZombiesOccurrences.push(j);
            }
        }
        _bOccurrencesSet = true;

    };
    this.getHealth = function () {
        return _oPlayer.getHealth();
    };

    this.getAmmo = function () {
        return _oPlayer.getAmmo();
    };
    this.ammoReload = function () {
        _oPlayer.reload();
    };
    this.spawn = function (iIndex)
    {

        var rand = Math.floor(randomFloatBetween(0, _aZombiePool.length));
        var oZombie  = _aZombiePool[iIndex];
        _aZombiesInGame.push(oZombie);
        oZombie.setVariables(_aZombiesOccurrences[rand], randomFloatBetween(400, 630), CANVAS_HEIGHT / 2 + 100, 1);
        _iSpawnTimer = 0;
        _iZombieOnScreen++;
    };

    this.damagePlayer = function () {
        _oPlayer.damage();
        _oInterface.damage();
        _iZombieOnScreen--;
        
        if (_oPlayer.getHealth() <= 0){
            _iCurrState = 3;
            s_oGame.gameOver();
        }
            
    };
    this.Shoot = function (e) {
        if (_bCanShoot){
            _oPlayer.Shoot(e);
            _oInterface.removeAmmoIcon();
        }
    };
    
    this.increaseScore = function (iScoreToBeAdded) {
        _iScore += iScoreToBeAdded;
        _iZombie++;
        _iZombieOnScreen--;
        
        
    };
    
    this.getScore = function () {
        if(_iZombie !== 0)
        return {zombie: _iZombie, wave: _iCurrWaveIndex + 1, score: (_iCurrWaveIndex +1) * 100 + _iScore};
    else
        return {zombie: _iZombie, wave: _iCurrWaveIndex + 1, score: 0};
    };
    
    this.gameOver = function(){        
        for (var i = 0; i < _aZombiesInGame.lenght; i++) {
            _aZombiesInGame[i].reset();
        }
        if (getItem(SCORE_ITEM_NAME) !== null) 
        {
           if(getItem(SCORE_ITEM_NAME) < this.getScore().score)
             saveItem(SCORE_ITEM_NAME ,this.getScore().score);
        }
        else
         saveItem(SCORE_ITEM_NAME ,this.getScore().score);

        $(s_oMain).trigger("end_level", 1);
        $(s_oMain).trigger("save_score", this.getScore().score);
        $(s_oMain).trigger("share_event", this.getScore().score);


        _oEndPanel.show();
    };
    
    this.updateAnim = function () {
        _bAnimTick = !_bAnimTick;
        if (_bAnimTick) {

            if (_iFrame === 0) {

                _aBgpng[_aBgpng.length - 1].visible = false;
                _aBgpng[0].visible = true;
            } else {
                _aBgpng[_iFrame - 1].visible = false;
                _aBgpng[_iFrame].visible = true;

            }

            _iFrame++;
            if (_iFrame > _aBgpng.length - 1) {
                _iFrame = 0;
            }
        }
        if (_bNormalAnim) {
            if (_bAnimEnded) {
                _bAnimEnded = false;
                if (_oContainer.x < 0)
                    new createjs.Tween.get(_oContainer).to({
                        x: 5,
                        y: -5
                    }, 500, createjs.Ease.sineOut).call(function () {
                        _bAnimEnded = true;
                    });
                else

                    new createjs.Tween.get(_oContainer).to({
                        x: -5,
                        y: 5
                    }, 500, createjs.Ease.sineOut).call(function () {
                        _bAnimEnded = true;
                    });
            }
        }
        else
        {
            if (_bAnimEnded) {
                _bAnimEnded = false;
                if (_oContainer.x < 0)
                    new createjs.Tween.get(_oContainer).to({
                        x: 60,
                        y: -50
                    }, 500, createjs.Ease.sineOut).call(function () {
                        _bAnimEnded = true;
                    });
                else

                    new createjs.Tween.get(_oContainer).to({
                        x: -80,
                        y: 50
                    }, 500, createjs.Ease.sineOut).call(function () {
                        _bAnimEnded = true;
                    });
            }
        }
    };
    this.updateSounds = function () {
        var iWave = _iCurrWaveIndex;

        if (iWave > _aWaveTargets.length)
        {
            iWave = _aWaveTargets.length - 1;
        }

        if (iWave === 3 || iWave === 6 || iWave === 9 || iWave === 12)
        {
            setVolume("zombie_crowd",0.4);
            setVolume("dog_horde",1);
        }
        else
        {
            setVolume("dog_horde",0.4);
            setVolume("zombie_crowd",1);
        }
    };

    this.update = function ()
    {
        
        if(!_bPause)
        {
        this.updateSounds();
      
        _oPlayer.update();
        _oInterface.refreshGUI();
        
        switch (_iCurrState)
        {
            //Waiting for wave
            case 0:
            {
                this.updateAnim();

                _iWaveTimer += s_iTimeElaps; //How Many Seconds are passed?
                if (_iWaveTimer/1000 > WAITING_TIME) //If the Timer has reached the Waiting Time, go To Game
                {
                    if (_bOccurrencesSet === false) //If the Occurrences are not set...
                    {

                        this.setOccurrences(); //...then Set Occurrences

                    }
                    else if (_bOccurrencesSet === true)
                    {
                        _iWaveTimer = 0;
                        _iSpawnTimer = 0;
                        _iZombieCount = 0;
                        _bWaveStarted = false;
                        _bWaveSpawnComplete = false;
                        _iCurrState = 1;

                    }
                }
                break;
            }
            //In-Game, you can shoot
            case 1:
            {
                this.updateAnim();
                _iSpawnTimer += s_iTimeElaps;
                var iWave = _iCurrWaveIndex;

                if (iWave > _aWaveTargets.length)
                {
                    iWave = _aWaveTargets.length - 1;
                }

                if (_iZombieCount < _aWaveTargets[iWave] && !_bWaveSpawnComplete)
                {
                    if (_iSpawnTimer/1000 > SPAWN_INTERVAL && _iZombieOnScreen < MAX_ZOMBIE_ON_SCREEN)
                    {
                        
                        this.spawn(_iZombieCount);
                        _iZombieCount++;

                        if (_bWaveStarted === false)
                            _bWaveStarted = true;
                    }
                }
                if (_bWaveStarted && _iZombieCount >= _aWaveTargets[iWave]) //If we spawned all zombies needed
                {
                    _bWaveSpawnComplete = true;
                    if (_aZombiesInGame.length <= 0) //...and There are not zombies in game
                    {
                        //Go to State = 0, Waiting for Wave, increase the wave index
                        _iCurrWaveIndex++;
                        _bOccurrencesSet = false;
                        _iCurrState = 0;
                    }
                }
                var aSortedArray = [];
                var prevY = 0;
                    for (var i = 0; i < _aZombiesInGame.length; i++)
                    {
                        //currY = _aZombiesInGame[i].getY();
                        _aZombiesInGame[i].update(_oPlayer.getAmmo() <=  0);
                        /*if (prevY < currY)
                        {
                              // _aZombiesInGame[i].setOnTop();

                            prevY = currY;

                        }*/
                        aSortedArray.push({zombie: _aZombiesInGame[i], lerp: _aZombiesInGame[i].getY()});
                    }
                    aSortedArray.sort(compare);

                    for (var i = 0; i < aSortedArray.length; i++)
                    {
                        _oAllZombieContainer.setChildIndex(aSortedArray[i].zombie.getContainer(), i);
                    }
                for (var i = 0; i < _aZombiesInGame.length; i++) {
                    if (_aZombiesInGame[i].getState() === 0) {
                        _aZombiesInGame.splice(i, 1);
                    }
                }



                break;

            }
            //We are death
            case 2:
            {

                createjs.Tween.get(_oFade).to({alpha: 1}, 1000);
                _iCurrState = 3;
                break;
            }
            //Game Over!
            case 3:
            {
                    

              break;
            }
            //default state, impossible to reach
            default:
            {
                break;

            }
        }
        }
    };
    s_oTweenController = new CTweenController();
    this._init();
}
var s_oGame;
var s_oTweenController;
