function CInterface(oSprite) {
    var _oAudioToggle;
    
    var _pStartPosAudio;
    var _pStartPosExit;
    var _pStartPosWave;
    var _pStartPosFullscreen;
    var _pStartPosReload;
    var _oHealthContainer;
    var _oHealthBar;
    var _oHealthFill;
    var _iHealthFactor;
    var _oAmmoContainer;
    var _oAmmoBar;
    var _aAmmoIcons;
    var _oWaveText;
    var _oButFullscreen;
    var _fRequestFullScreen = null;
    var _fCancelFullScreen = null;
    var _oButExit;
    var _oButReload;
    var _oButHelp;
    var _bAnimTick;
    var _oMask;
    var _pStartPosHelp;
    var _oContainerWave;
    
    this._init = function () {
        _aAmmoIcons = [];
        var oSpriteExit = s_oSpriteLibrary.getSprite('but_exit');
        _pStartPosExit = {x: CANVAS_WIDTH - oSpriteExit.width/2 - 10, y: (oSpriteExit.height / 2) + 10};
        _oButExit = new CGfxButton(_pStartPosExit.x, _pStartPosExit.y, oSpriteExit,s_oStage);
        _oButExit.addEventListener(ON_MOUSE_UP, this._onExit, this);
        var oSpriteReload = s_oSpriteLibrary.getSprite('but_reload');
        _pStartPosReload = {x: oSpriteReload.width/2 + 20, y: CANVAS_HEIGHT - 100};

        _oButReload = new CGfxButton(_pStartPosReload.x, _pStartPosReload.y, oSpriteReload, s_oStage);
        _oButReload.addEventListener(ON_MOUSE_DOWN, this.ammoReload, this);
        _oHealthContainer = new createjs.Container();
        _oHealthBar = createBitmap(s_oSpriteLibrary.getSprite("health_bar"));
        _oMask = new createjs.Shape();
        _oMask.graphics.beginFill("rgba(255,255,255,0.01)").drawRect(_oHealthBar.x, _oHealthBar.y, _oHealthBar.getBounds().width, _oHealthBar.getBounds().height);


        _oHealthFill = createBitmap(s_oSpriteLibrary.getSprite("health_fill"));
        _oHealthFill.x = 4;
        _oHealthFill.y = 4 ;
        _oHealthFill.mask = _oMask;

        
        _bAnimTick = true;
       var oAvatar = createBitmap(s_oSpriteLibrary.getSprite("avatar"));
        oAvatar.x = -50;
        oAvatar.y = -20;
        _oHealthContainer.addChild(_oHealthBar);
        _oHealthContainer.addChild(oAvatar);
        _oHealthContainer.addChild(_oHealthFill);
                _oHealthContainer.addChild(_oMask);

        _iHealthFactor = 0.98/PLAYER_HEALTH;
        _oAmmoContainer = new createjs.Container();
        _oAmmoBar = createBitmap(s_oSpriteLibrary.getSprite("bullet_bar"));
        
        _oAmmoContainer.addChild(_oAmmoBar);
        _oAmmoContainer.y = CANVAS_HEIGHT - 10;
        
        _pStartPosWave = {x:CANVAS_WIDTH-10,y:CANVAS_HEIGHT-10};
        _oContainerWave = new createjs.Container();
        _oContainerWave.x = _pStartPosWave.x;
        _oContainerWave.y = _pStartPosWave.y;
        _oContainerWave.regX = 200;
        _oContainerWave.regY = 50;
        s_oStage.addChild(_oContainerWave);
        
        _oWaveText = new CTLText(_oContainerWave, 
                    0, 0, 200, 50, 
                    50, "right", "#990000", PRIMARY_FONT, 1,
                    0, 0,
                    TEXT_WAVE+s_oGame.getScore().wave,
                    true, true, false,
                    false );

        var iXBullet = 19;
        for (var b = 0; b <= STARTING_AMMO - 1; b++)
        {
            var oBullet = createBitmap(s_oSpriteLibrary.getSprite("bullet"));
            _aAmmoIcons.push(oBullet);
            _oAmmoContainer.addChild(oBullet);
            oBullet.x = iXBullet;
            oBullet.y = -10;
            oBullet.scaleX = 1;
            oBullet.scaleY = 1;
            iXBullet += 20;
        }

        s_oStage.addChild(_oAmmoContainer);
       

        s_oStage.addChild(_oHealthContainer);
        _oHealthContainer.x = 60;
        _oHealthContainer.y = 30;


        if (DISABLE_SOUND_MOBILE === false || s_bMobile === false){
            var oSprite = s_oSpriteLibrary.getSprite('audio_icon');
            
            _pStartPosAudio = {x: _pStartPosExit.x - oSpriteExit.width/2 - oSprite.width/4 - 10, y: _pStartPosExit.y};
            _oAudioToggle = new CToggle(_pStartPosAudio.x, _pStartPosAudio.y, oSprite, s_bAudioActive,s_oStage);
            _oAudioToggle.addEventListener(ON_MOUSE_UP, this._onAudioToggle, this);
            _pStartPosFullscreen = {x: _pStartPosAudio.x - oSprite.width/2  - 10,y:_pStartPosAudio.y};
        }else{
            _pStartPosFullscreen = {x: _pStartPosExit.x - oSpriteExit.width - 10, y: _pStartPosExit.y};
        }

        var doc = window.document;
        var docEl = doc.documentElement;
        _fRequestFullScreen = docEl.requestFullscreen || docEl.mozRequestFullScreen || docEl.webkitRequestFullScreen || docEl.msRequestFullscreen;
        _fCancelFullScreen = doc.exitFullscreen || doc.mozCancelFullScreen || doc.webkitExitFullscreen || doc.msExitFullscreen;
        
        if(ENABLE_FULLSCREEN === false){
            _fRequestFullScreen = false;
        }
        var oSpriteHelp = s_oSpriteLibrary.getSprite('but_credits');

        if (_fRequestFullScreen && screenfull.enabled){
            oSprite = s_oSpriteLibrary.getSprite('but_fullscreen');

            _oButFullscreen = new CToggle(_pStartPosFullscreen.x,_pStartPosFullscreen.y,oSprite,s_bFullscreen,s_oStage);
            _oButFullscreen.addEventListener(ON_MOUSE_UP, this._onFullscreenRelease, this);
            
            _pStartPosHelp = {x: _pStartPosFullscreen.x- oSpriteHelp.width - 10, y: _pStartPosFullscreen.y};
        }else{
            _pStartPosHelp = {x: _pStartPosFullscreen.x, y: _pStartPosFullscreen.y};
        }
        
        _oButHelp = new CGfxButton(_pStartPosHelp.x, _pStartPosExit.y, oSpriteHelp,s_oStage);
        _oButHelp.addEventListener(ON_MOUSE_UP, this._showHelp, this);
        
        
        this.refreshButtonPos(s_iOffsetX, s_iOffsetY);
        this.refreshGUI();
    };

    this.refreshButtonPos = function (iNewX, iNewY) {
        if (DISABLE_SOUND_MOBILE === false || s_bMobile === false) {
            _oAudioToggle.setPosition(_pStartPosAudio.x - iNewX, _pStartPosAudio.y + iNewY);
        }
        if (_fRequestFullScreen && screenfull.enabled){
            _oButFullscreen.setPosition(_pStartPosFullscreen.x - iNewX,_pStartPosFullscreen.y + iNewY);
        }
        _oHealthContainer.x = 60 + iNewX;
        _oHealthContainer.y = 30 + iNewY;
        _oAmmoContainer.x = iNewX;
        _oAmmoContainer.y = CANVAS_HEIGHT - _oAmmoContainer.getBounds().height/2 - 20 - iNewY;
        _oButExit.setPosition(_pStartPosExit.x - iNewX, _pStartPosExit.y + iNewY);
        _oButReload.setPosition( _pStartPosReload.x + iNewX, _pStartPosReload.y - iNewY);
        _oButHelp.setPosition( _pStartPosHelp.x + iNewX, _pStartPosHelp.y+ iNewY);
        _oContainerWave.x = _pStartPosWave.x- iNewX;
        _oContainerWave.y = _pStartPosWave.y- iNewY;

    };

   
    
    this.unload = function () {
        
        if (DISABLE_SOUND_MOBILE === false || s_bMobile === false) {
            _oAudioToggle.unload();
            _oAudioToggle = null;
        }
        
        if (_fRequestFullScreen && screenfull.enabled){
            _oButFullscreen.unload();
        }

        _oButExit.unload();
        s_oInterface = null;
    };
    
    this._showHelp = function () 
    {
      s_oGame.showHelp();  
    };
    this._onExit = function () {
       // s_oGame.onExit();
       new CAreYouSurePanel();
    };

    this._onAudioToggle = function () {
        Howler.mute(s_bAudioActive);
        s_bAudioActive = !s_bAudioActive;
    };
    this.removeAmmoIcon = function () {
        var removed = false;
        for (var b = _aAmmoIcons.length - 1; b >= 0; b--)
        {
            if (removed === false) {
                if (_aAmmoIcons[b].visible === true) {
                    _aAmmoIcons[b].visible = false;
                    removed = true;
                }
            }
        }
    };
    this.ammoReload = function () {
        s_oGame.ammoReload();

        for (var b = 0; b < _aAmmoIcons.length; b++)
        {
            _aAmmoIcons[b].visible = true;
        }
    };
    this.damage = function ()
    {

        _oMask.scaleX -= _iHealthFactor;
    };
    
    this.resetFullscreenBut = function(){
        if (_fRequestFullScreen && screenfull.enabled){
            _oButFullscreen.setActive(s_bFullscreen);
        }
    };
        
    this._onFullscreenRelease = function(){
	if(s_bFullscreen) { 
		_fCancelFullScreen.call(window.document);
	}else{
		_fRequestFullScreen.call(window.document.documentElement);
	}
	
	sizeHandler();
    };
    
    this.refreshGUI = function () 
    {
        if (s_oPlayer.getAmmo() <= 0 && _bAnimTick)
        {
            _bAnimTick = false;
            _oButReload.pulseAnimation();
        }
        else if (s_oPlayer.getAmmo() > 0)
        {
            _bAnimTick = true;
            _oButReload.removeAllTweens();
        } 
           
      _oWaveText.refreshText(TEXT_WAVE + s_oGame.getScore().wave);
    };
    s_oInterface = this;

    this._init(oSprite);

    return this;
}

var s_oInterface = null;