function CPlayer (oSprite)
{
    var _iAmmo;
    var _iHealth;
    var _oSpriteR;
    var _oSpriteL;
    var _oDamageSprite;
    var _bAnimTick;
    var _iAnimTimer;
    var _aHandsSprite;
    var _oContainer;
    
    var _pSpriteLPos;
    var _pSpriteRPos;
    var _aHandPos;
    this._init = function () {
        
        _iAmmo = STARTING_AMMO;
        _iHealth = PLAYER_HEALTH;
        _oContainer = new createjs.Container();
        _oContainer.setBounds(0,0,CANVAS_WIDTH, CANVAS_HEIGHT);
        var data_right = {
             images: [s_oSpriteLibrary.getSprite("player_right")],
            frames: {width: 847 / 2, height: 323, regX: 847/2, regY: 646/2},
            animations: {idle: 0, fire: 1}
        };
       
        var data_left = {
            images: [s_oSpriteLibrary.getSprite("player_left")],
            frames: {width: 791 / 2, height: 657/2, regX: 0, regY: 657/2},
            animations: {idle: 0, fire: 1}
        };
        var spriteSheetR = new createjs.SpriteSheet(data_right);
        var spriteSheetL = new createjs.SpriteSheet(data_left);
        _oSpriteR = new  createjs.Sprite(spriteSheetR);
        _oSpriteL = new  createjs.Sprite(spriteSheetL);

        _oSpriteL.visible = false;
        _oSpriteR.visible = true;
        _aHandsSprite = [];
        _aHandsSprite.push(_oSpriteR, _oSpriteL);
       
       _pSpriteLPos = {x: -80, y: CANVAS_HEIGHT +60};
        _oSpriteL.x = -80;
        _oSpriteL.y = CANVAS_HEIGHT + 60;

       _pSpriteRPos = {x: CANVAS_WIDTH+100, y: CANVAS_HEIGHT +60};

        _oSpriteR.x = CANVAS_WIDTH + 100;
        _oSpriteR.y = CANVAS_HEIGHT + 60;
        _aHandPos = [];
        _aHandPos.push(_pSpriteRPos, _pSpriteLPos);

        _oContainer.addChild(_oSpriteR);
        _oContainer.addChild(_oSpriteL);
        s_oStage.addChild(_oContainer);


        _oDamageSprite = createBitmap(s_oSpriteLibrary.getSprite("damage"));
        s_oStage.addChild(_oDamageSprite);
        _oDamageSprite.alpha = 0;

        _bAnimTick = false;
        _iAnimTimer = 0;
    };
    this.handleMovement = function (e)
    {
        var x = e.stageX / s_iScaleFactor;
        var y = e.stageY / s_iScaleFactor;
        var portion = CANVAS_WIDTH  * 0.5;
        if (x > portion)
        {
            _oSpriteL.visible = true;
            _oSpriteR.visible = false;
        }
        else
        {
            _oSpriteR.visible = true;
            _oSpriteL.visible = false;
        }
    };
    this.getAmmo = function () {
        return _iAmmo;
    };
    this.getHealth = function () {
        return _iHealth;
    };

    this.damage = function () {
        _oDamageSprite.alpha = 1;
        if (_iHealth -1 > 0){
            var rand = Math.round(randomFloatBetween(1,2.1) -1);
        }
        else
            var rand = 0;

        playSound("player_hit_"+rand,1,false);
        new createjs.Tween.get(_oDamageSprite).to({alpha: 0}, 700);
        _iHealth--;
    };
    this.Shoot = function (e){
        if (_iAmmo > 0 ) {
            this.handleMovement(e);
            _iAmmo--;
            playSound("shoot",1,false);
            s_oGame.toggleShoot(false);
            
            for (var i = 0; i < _aHandsSprite.length; i++){
                var iOffsetX = -15;
                if (i === 0)
                    iOffsetX = 15;
             new createjs.Tween.get(_aHandsSprite[i]).to({y: _aHandPos[i].y +30, x: _aHandPos[i].x+iOffsetX}, 100).to({y:  _aHandPos[i].y,x: _aHandPos[i].x }, 150).call(function(){s_oGame.toggleShoot(true);});
            _aHandsSprite[i].gotoAndStop("fire");
            }
            _bAnimTick = true;

        }

        playSound("dry_gun",1,false);
    };
    
    this.setVisible = function (bool)
    {
        if (bool)
            for (var i = 0; i < _aHandsSprite.length; i++)
            {
                if (i !== 1)
                    _aHandsSprite[i].visible = false;
                else
                    _aHandsSprite[i].visible = true;

            }
        else
            for (var i = 0; i < _aHandsSprite.length; i++)
            {
            _aHandsSprite[i].visible = false;
    }
    };
    this.reload = function () {
        _iAmmo = STARTING_AMMO;
        playSound("revolver_reload",1,false);
    };
    this.update = function () {

        if ( _bAnimTick) {
            _iAnimTimer += s_iTimeElaps;
            if (_iAnimTimer >=150){
                _bAnimTick = false;
                for (var i = 0; i < _aHandsSprite.length; i++)
                {
                    _aHandsSprite[i].gotoAndStop("idle");
                }
                _iAnimTimer = 0;
            }
        }
    };
    this._init(oSprite);
    s_oPlayer = this;
}

var s_oPlayer;