function CZombie (iType, iX, iY, oParent ) {

    var _iHealth;
    var _aWalk;
    var _aHit;
    var _aDeath;
    var _oZombieContainer;
    var _bShootable;
    var _iType;
    var _iRunFrame;
    var _iDeathFrame;
    var _iHitFrame;
    var _bReloading = false;
    var _bAnimFinished = false;
    var _iCurrState = 0; //DISABLED, RUNNING, HIT, DEAD
    var _iDeadTimer = 0;
    var _oParentContainer;
    var _bAnimTickReset;
    var _oMask;
    var _iTweenReferenceFrame;
    var _iTweenReferenceFrameDeath;
    var _iTweenMaxFrame;
    var _oBloodSprite;
    var startX;
    var startY;
    var startScaleX;
    var startScaleY;
    var deathY;
    var deathScaleX;
    var deathScaleY;
    var _iWalkFrameStart;
    var _iWalkFrameEnd;
    var _iHitFrameStart;
    var _iHitFrameEnd;
    var _iHitFrameToDeath;
    var _iDeathFrameStart;
    var _iDeathFrameEnd;
    var _bTween;
    var _iPercCompletedTween;
    var _oListener;
    
    this.init = function (iType, iX, iY, oParent)
    {
        _bAnimTickReset = false;
        _aWalk = [];
        _aHit = [];
        _aDeath = [];
        _oZombieContainer = new createjs.Container();
        _oParentContainer = oParent;
        _iHealth = ZOMBIE_HEALTHS[iType];

        _iCurrState = 0;
    };

    this.setVariables = function (iType, iX, iY, iState)
    {
        _bAnimTickReset = false;
        _aWalk = [];
        _aHit = [];
        _aDeath = [];
        _oZombieContainer = new createjs.Container();
        _iType = iType;
        _bAnimFinished = false;
        var data = {
            images: [s_oSpriteLibrary.getSprite("blood")],
            frames: {width: 320, height: 351, regX: 160, regY: 175},
            animations: {idle: [0, 11],
                        stop: 0}
        };
        var spriteSheet = new createjs.SpriteSheet(data);
        _oBloodSprite = new  createjs.Sprite(spriteSheet,"stop");
        _oBloodSprite.visible = false;
        _oBloodSprite.scaleX = 0.5;
        _oBloodSprite.scaleY = 0.5;
        
        
        //We store the frame references for the animations in local variables
        _iWalkFrameStart = ANIM_Z[iType].anim.walk.start;
        _iWalkFrameEnd = ANIM_Z[iType].anim.walk.end;
        _iHitFrameStart = ANIM_Z[iType].anim.hit.start;
        _iHitFrameEnd = ANIM_Z[iType].anim.hit.end;
        _iHitFrameToDeath = ANIM_Z[iType].anim.hit.todeath;
        _iDeathFrameStart = ANIM_Z[iType].anim.death.start;
        _iDeathFrameEnd = ANIM_Z[iType].anim.death.end;

        //We attach every frame of every animation to the container
        for (var i = _iWalkFrameStart; i<= _iWalkFrameEnd; i++)
        {
            var oWalkFrame= createBitmap(s_oSpriteLibrary.getSprite("zombie"+iType+"_"+i));
            _aWalk.push(oWalkFrame);
            oWalkFrame.visible = false;
            _oZombieContainer.addChild(oWalkFrame);
        }
        for (var i =_iHitFrameStart; i <=_iHitFrameEnd; i++)
        {
                var oHitFrame = createBitmap(s_oSpriteLibrary.getSprite("zombie"+iType+"_"  + i));
                _aHit.push(oHitFrame);
            oHitFrame.visible = false;
                _oZombieContainer.addChild(oHitFrame);
        }
        for (var i =_iDeathFrameStart; i <=_iDeathFrameEnd; i++)
        {
            var oDeathFrame = createBitmap(s_oSpriteLibrary.getSprite("zombie"+iType+"_"  + i));
            _aDeath.push(oDeathFrame);
            if (_iType !== 3) {
                oDeathFrame.x -= 50;
                oDeathFrame.y += 20;
            }
            oDeathFrame.visible = false;
            _oZombieContainer.addChild(oDeathFrame);
        }

        //We need to set the reference for the Tween to 6 seconds (with the exception of the zombie n.2)
        _iTweenReferenceFrame =0;
        _iTweenReferenceFrameDeath =0;
        if (_iType !== 2 && _iType !== 3)
        _iTweenMaxFrame = 240;
        else
            _iTweenMaxFrame = 80;
        
        _iPercCompletedTween = 0;
        //Here we initialize the frame counters and set the position
        _iHitFrame = 0;
        _iRunFrame = Math.floor(randomFloatBetween(0, _iWalkFrameEnd ));
        _iDeathFrame = 0;
        _bTween = true;
        _aWalk[0].visible = true;
        _iHealth = ZOMBIE_HEALTHS[iType];
        _oZombieContainer.x = startX =iX;
        _oZombieContainer.y = startY = iY;


        _oMask = new createjs.Shape();
        _oMask.graphics.beginFill("rgba(255,0,0,0.6)").drawRect(0, 0, 10, _oZombieContainer.getBounds().height);
        _oMask.x = _aWalk[0].x - 40;
        _oMask.y = _aWalk[0].y;
        _oMask.visible = false;
        _oZombieContainer.addChild(_oMask);
        s_oStage.addChild(_oBloodSprite);
        _iCurrState = iState;
        _oZombieContainer.regX = _oZombieContainer.getBounds().width/2;
        _oZombieContainer.regY = _oZombieContainer.getBounds().height;
        _oZombieContainer.scaleX = startScaleX =  0.12;
        _oZombieContainer.scaleY = startScaleY =  0.12;
        _oZombieContainer.alpha = 0;
        _oParentContainer.addChild(_oZombieContainer);
        //if (_iType !== 2 && _iType !== 3)
        //_oParent.setChildIndex(_oZombieContainer, 2);

        if (_iType !== 2 && _iType !== 3)
        createjs.Tween.get(_oZombieContainer).to({alpha: 1}, 3000, createjs.Ease.cubicIn);
        else
        createjs.Tween.get(_oZombieContainer).to({alpha: 1}, 1000, createjs.Ease.cubicIn);

        _oListener = _oZombieContainer.on("mousedown", this.onClick);
    };

    this.onClick = function (e){
        if (_bShootable){
            if(_bReloading){
                playSound("dry_gun",1,false);
                return;
            }
            
            if (_iType === 2){
                _oZombieContainer.mouseEnabled = false;
            }
            
            _oBloodSprite.scaleX = _oZombieContainer.scaleX;
            _oBloodSprite.scaleY = _oZombieContainer.scaleY;
            _oBloodSprite.x = e.stageX / s_iScaleFactor;
            _oBloodSprite.y = e.stageY / s_iScaleFactor;

            _oBloodSprite.visible = true;
            _oBloodSprite.gotoAndPlay("idle");
            _oMask.visible = true;
            _iCurrState = 2;
            _iHitFrame = 0;
            
            s_oGame.Shoot(e);
            _iHealth--;
            if (_iHealth > 0)
            iHealthMod = _iHealth / ZOMBIE_HEALTHS[_iType];
            else {
                iHealthMod = 0;
                s_oGame.increaseScore(ZOMBIE_HEALTHS[_iType]);


            }
            new createjs.Tween.get(_oMask).to({scaleY: iHealthMod}, 200).call(function () {
                new createjs.Tween.get(_oMask).to({visible: false}, 100);
            });
        }
    };
    
    this.setOnTop = function () {
       // _oParent.setChildIndex(_oZombieContainer, _oParent.numChildren -1);
    };
    this.getType = function () {
        return _iType;
    };
    this.getContainer = function () 
    {
      return _oZombieContainer;  
    };
    this._animRun = function ()
    {
        for (var i = 0; i < _aHit.length; i++)
            _aHit[i].visible = false;


        if (_iRunFrame === 0) {

            _aWalk[_aWalk.length - 1].visible = false;
            _aWalk[0].visible = true;
        } else {
            _aWalk[_iRunFrame - 1].visible = false;
            _aWalk[_iRunFrame].visible = true;

        }

        _iRunFrame++;
        if (_iRunFrame > _aWalk.length - 1) {
            _iRunFrame = 0;
        }
    };
    this.getY = function () {
        return _iTweenReferenceFrame * 100 / _iTweenMaxFrame;
    };
    
    this._animDeath = function ()
    {
        if(_iType !== 2) {
            for (var i = 0; i < _aHit.length; i++)
                _aHit[i].visible = false;

            if (_iDeathFrame === 0) {

                _aDeath[_aDeath.length - 1].visible = false;
                _aDeath[0].visible = true;
            } else {
                _aDeath[_iDeathFrame - 1].visible = false;
                _aDeath[_iDeathFrame].visible = true;

            }

            _iDeathFrame++;
            if (_iDeathFrame > _aDeath.length - 1) {

                this.reset();
            }
        }
        else
        this.reset();
    };
    this.getState = function () {
        return _iCurrState;
    };
    this._animHit = function ()
    {

        for (var i = 0; i < _aWalk.length; i++)
            _aWalk[i].visible = false;
        
        if (_bAnimFinished === false)
            for (var i = 0; i < _aHit.length; i++)
                _aHit[i].visible = false;
        if (_iHitFrame === 0){   
            playSound("hit_zombie_"+_iType,1,false);
            _aHit[_aHit.length - 1].visible = false;
            _aHit[0].visible = true;
        }
        else
        {
            _aHit[_iHitFrame - 1].visible = false;
            _aHit[_iHitFrame].visible = true;
        }
        _iHitFrame++;

        if (_iHitFrame > _iHitFrameToDeath && _iHealth <= 0)
        {
            deathScaleX = _oZombieContainer.scaleX;
            deathScaleY = _oZombieContainer.scaleY;
            deathY = _oZombieContainer.y;
            _iCurrState = 3;
        }
        if (_iHitFrame >= _aHit.length && _iHealth >0)
        {
            _bAnimFinished = true;
            _iCurrState = 1;
        }

    };

    this.reset = function () {
        _iCurrState = 0;
        _oZombieContainer.off("mousedown", _oListener);
        createjs.Tween.removeTweens (_oZombieContainer);
        createjs.Tween.get(_oZombieContainer).to({alpha: 0}, 500).call(function () {
            _oParentContainer.removeChild(_oZombieContainer);
            for (var i = 0; i < _aWalk.length; i++)
                _aWalk[i].visible = false;
            for (var i = 0; i < _aHit.length; i++)
                _aHit[i].visible = false;
            for (var i = 0; i < _aDeath.length; i++)
                _aDeath[i].visible = false;
            _aHit = [];
            _aWalk = [];
            _aDeath = [];

        });
    };
    this.update = function (bReloading)
    {
        if (_oBloodSprite.currentFrame === 11)
        {
            _oBloodSprite.visible = false;
        }
        _bReloading = bReloading;
        switch (_iCurrState) {
            case 0: //DISABLED STATE
            {
                _oZombieContainer.mouseEnabled = true;
                _bShootable = false;
                break;
            }
            case 1: //RUNNING STATE
            {
                _oZombieContainer.mouseEnabled = true;

                _iTweenReferenceFrame++;
                if (_iTweenReferenceFrame > _iTweenMaxFrame)
                    _iTweenReferenceFrame = _iTweenMaxFrame;
                var fLerpY = s_oTweenController.easeInCubic( _iTweenReferenceFrame, 0 ,1, _iTweenMaxFrame);
                var iValueY = s_oTweenController.tweenValue( startY, CANVAS_HEIGHT + 300, fLerpY);
                _oZombieContainer.y = iValueY;
                var iFactor = 2;
                var fLerpScaleX = s_oTweenController.easeInCubic( _iTweenReferenceFrame, 0 ,1, _iTweenMaxFrame);
                var iValueScaleX = s_oTweenController.tweenValue( startScaleX *iFactor, 1 * iFactor, fLerpScaleX);
                _oZombieContainer.scaleX = iValueScaleX;
                var fLerpScaleY = s_oTweenController.easeInCubic( _iTweenReferenceFrame, 0 ,1, _iTweenMaxFrame);
                var iValueScaleY = s_oTweenController.tweenValue( startScaleY * iFactor, 1 *iFactor, fLerpScaleY);
                _oZombieContainer.scaleY= iValueScaleY;
                this._animRun();

                _bShootable = true;
                if (_oZombieContainer.y >= CANVAS_HEIGHT + 250) {
                    if (_iType === 2)
                        playSound("dog_attack",1,false);
                    s_oGame.damagePlayer();
                    createjs.Tween.get(_oZombieContainer).to({alpha: 0}, 200).call(function () {
                        _oBloodSprite.visible = false;
                    });
                    _iCurrState = 0;

                }
                break;
            }
            case 2: //HIT STATE
            {

                this._animHit();
                
                if(_iType !== 2)
                _oZombieContainer.mouseEnabled = true;
                
                else
                _oZombieContainer.mouseEnabled = false;
                _bShootable = true;
                break;
            }
            case 3: //DEAD STATE
            {
                _oBloodSprite.visible = false;

                _iTweenReferenceFrameDeath++;
                
                var _iTweenMaxFrameDeath = 80;
                if (_iTweenReferenceFrameDeath >= _iTweenMaxFrameDeath)
                    _iTweenReferenceFrameDeath = _iTweenMaxFrameDeath;
                var fLerpY = s_oTweenController.easeInCubic( _iTweenReferenceFrameDeath, 0 ,1, _iTweenMaxFrameDeath);
                var iValueY = s_oTweenController.tweenValue( deathY, deathY + 90, fLerpY);
                _oZombieContainer.y = iValueY;
                var iFactor = 1;
                var fLerpScaleX = s_oTweenController.easeInCubic( _iTweenReferenceFrameDeath, 0 ,1,
                                                            _iTweenMaxFrameDeath);
                var iValueScaleX = s_oTweenController.tweenValue( deathScaleX *iFactor, (deathScaleX + 1) * iFactor, fLerpScaleX);
                _oZombieContainer.scaleX = iValueScaleX;
                var fLerpScaleY = s_oTweenController.easeInCubic( _iTweenReferenceFrameDeath, 0 ,1, _iTweenMaxFrameDeath);
                var iValueScaleY = s_oTweenController.tweenValue( deathScaleY * iFactor, (deathScaleY + 1) *iFactor, fLerpScaleY);
                _oZombieContainer.scaleY= iValueScaleY;

                _oZombieContainer.mouseEnabled = false;
                this._animDeath();
                 _oZombieContainer.mouseEnabled = false;

                _bShootable = false;

                break;

            }
            default :
                break;
        }

    };
    this.init(iType, iX, iY,oParent);

}

